package dev.boyfailure.quajra.vectorbreakout;

public class Brick {
    
    short brickX;
    short brickY;
    short brickWidth = 40;
    short brickHeight = 17;
    boolean isBroken = false;
    byte brickColor = 0;
    byte scoreOnBreak = 10;
    byte specialAbility = 0;
    
    public Brick(int x, int y, boolean bk, int bc, int sc, int sa) {
        this.brickX = (short) x;
        this.brickY = (short) y;
        this.isBroken = bk;
        this.brickColor = (byte) bc;
        this.scoreOnBreak = (byte) sc;
        this.specialAbility = (byte) sa;
    }
    
    public void breakBrick() {
        if (!isBroken) {
            isBroken = true;
            VectorBreakout.score += this.scoreOnBreak + (VectorBreakout.level - 1);
            VectorBreakout.bricksOnScreen--;
            switch(this.specialAbility) {
                case 1:
                    VectorBreakout.lives++;
                    break;
                case 2:
                    for (byte i = 0; i < VectorBreakout.currentBalls.length; i++) {
                        if (VectorBreakout.currentBalls[i] == null) {
                            VectorBreakout.currentBalls[i] = new Ball(300, 300, 7, 7, 0, true);
                            VectorBreakout.currentBalls[i].spawnBall((this.brickX + (this.brickWidth / 2)), (this.brickY + (this.brickHeight / 2)));
                            return;
                        }
                    }
                    break;
                default:
                    break;
            }
        }
        
        // Draw particles
        byte brickParticleGen = 0;
        for (byte ii = 0; ii < VectorBreakout.currentParticles.length; ii++) {
            if (VectorBreakout.currentParticles[ii] == null) {
                brickParticleGen++;
                switch(brickParticleGen) {
                    case 1:
                        VectorBreakout.currentParticles[ii] = new Particle(0, this.brickX, this.brickY, this.brickWidth - 1, 3, this.brickColor, 3, 3, 2);
                        VectorBreakout.currentParticles[ii].spawn(20);
                        break;
                    case 2:
                        VectorBreakout.currentParticles[ii] = new Particle(0, this.brickX, this.brickY, -2, this.brickHeight - 1, this.brickColor, 3, 3, 2);
                        VectorBreakout.currentParticles[ii].spawn(20);
                        break;
                    case 3:
                        VectorBreakout.currentParticles[ii] = new Particle(0, this.brickX, this.brickY + this.brickHeight, this.brickWidth - 1, 2, this.brickColor, 3, 3, 2);
                        VectorBreakout.currentParticles[ii].spawn(20);
                        break;
                    case 4:
                        VectorBreakout.currentParticles[ii] = new Particle(0, this.brickX + this.brickWidth, this.brickY, -2, this.brickHeight, this.brickColor, 3, 3, 2);
                        VectorBreakout.currentParticles[ii].spawn(20);
                        break;
                }
                if (brickParticleGen < 4) {continue;}
                else {return;}
            }
        }
        
        this.brickX = 32767;
        this.brickY = 32767;
    }
    
}
