package dev.boyfailure.quajra.vectorbreakout;

public class Paddle {
    
    short paddleX;
    short paddleY;
    short paddleWidth = 100;
    short paddleHeight = 7;
    byte paddleColor;
    byte paddleSpeed = 0;
    boolean isActive = true;
    float speedMultiplier = 1;
    
    public Paddle(int x, int y, int w, int h, int bc, float sm) {
        this.paddleX = (short) x;
        this.paddleY = (short) y;
        this.paddleWidth = (short) w;
        this.paddleHeight = (short) h;
        this.paddleColor = (byte) bc;
        this.speedMultiplier = sm;
    }
    
    public void movePaddle(boolean direction) {
        if (this.paddleSpeed <= 15) {this.paddleSpeed += 3;}
        if (direction) {this.paddleX += (this.paddleSpeed * this.speedMultiplier);}
        else {this.paddleX -= (this.paddleSpeed * this.speedMultiplier);}
        if (this.paddleX <= 20) {this.paddleX = 20;}
        else if (this.paddleX >= (VectorBreakout.gameResX - this.paddleWidth - 20)) {this.paddleX = (short) (VectorBreakout.gameResX - this.paddleWidth - 20);}
    }
    
    public void cullPaddle() {
        isActive = false;
        this.paddleX = 32767;
        this.paddleY = 32767;
    }

}
