package dev.boyfailure.quajra.vectorbreakout;

public class Particle {
    
    byte particleID;
    short particleX;
    short particleY;
    short particleX2;
    short particleY2;
    boolean isActive = true;
    byte particleColor;
    short particleFrame = 0;
    short particleLifetime;
    float vectorScale = 1;
    byte particleDirection;
    byte particleSpeed = 2;
    
    public Particle(int pid, int x, int y, int x2, int y2, int pc, float sc, int dir, int speed) {
        this.particleID = (byte) pid;
        this.particleX = (short) x;
        this.particleY = (short) y;
        this.particleX2 = (short) x2;
        this.particleY2= (short) y2;
        this.particleColor = (byte) pc;
        this.vectorScale = sc;
        this.particleDirection = (byte) dir;
        this.particleSpeed = (byte) speed;
    }
    
    public void spawn(int lifetime) {
        this.isActive = true;
        this.particleLifetime = (short) lifetime;
    }
    
    public void update() {
        this.particleFrame++;
        if (this.particleDirection != 0) {
            switch(this.particleDirection) {
                case 1:this.particleX += this.particleSpeed;break;
                case 2:this.particleX += this.particleSpeed;this.particleY+= this.particleSpeed;break;
                case 3:this.particleY += this.particleSpeed;break;
                case 4:this.particleX -= this.particleSpeed;this.particleY+= this.particleSpeed;break;
                case 5:this.particleX -= this.particleSpeed;break;
                case 6:this.particleX -= this.particleSpeed;this.particleY-= this.particleSpeed;break;
                case 7:this.particleY -= this.particleSpeed;break;
                case 8:this.particleX += this.particleSpeed;this.particleY-= this.particleSpeed;break;
            }
        }
        if (this.particleFrame >= this.particleLifetime) {
            this.isActive = false;
        }
    }
    
}
